/*
 * Created on May 14, 2007
 */
package com.x8ing.lsm4j;

import java.util.List;

import com.x8ing.lsm4j.state.ProcessableState;

/**
 * An Action implements the logic that should be processed if the graph reach a
 * certain point. An action can be attached to state or optionally to a
 * transition.
 * <p>
 * The optional StateMetaInformation can be retrieved from {@link ProcessableState#getStateMetaInformation()}.
 *
 * @author Patrick Heusser
 */
public interface Action {

    /**
     * Will be invoked to process the current state.
     *
     * @param currentState
     * @param stateContext
     * @param previousCondition
     * @param lastVisitedStatesHistory
     *            Contains the last visited states as a list. The element with
     *            index 0 ist the current State. The size of the history is
     *            defined in the graph. Type: {@link ProcessableState}
     *
     */
    public void execute(ProcessableState currentState, StateContext stateContext, Condition previousCondition,
            List lastVisitedStatesHistory);

}
