package com.x8ing.lsm4j.state;

/**
 * A graph can be configured to run infinite or with a hard limit of transitions.
 * If in the hard limit mode the count of transitions exceeds the specified limit, this
 * exception is thrown, regardless if the current state is an end state or not.
 * <p>
 * {@link com.x8ing.lsm4j.state.ProcessableGraph#setMaximumLoops(long)}
 *
 * @author Patrick Heusser
 */
public class MaximumIterationsReachedException extends AbstractProcessableGraphException {

	private static final long serialVersionUID = 1L;

	private long maximumIterationsSpecified = -1;

	public long getMaximumIterationsSpecified() {
		return maximumIterationsSpecified;
	}

	public void setMaximumIterationsSpecified(long maximumIterationsSpecified) {
		this.maximumIterationsSpecified = maximumIterationsSpecified;
	}

}
