/*
 * Created on May 14, 2007
 */
package com.x8ing.lsm4j.state;

/**
 * After a state has been processed the controler tries to figure out how to go on. All attached transitions are
 * evaluated. If no of all conditions results in true, the {@link ProcessableGraph} throws this exception.
 * 
 * @author Patrick Heusser
 */
public class NoMatchingTransitionConditionFoundException extends AbstractProcessableGraphException {

	private static final long serialVersionUID = 1L;

	private ProcessableTransition currentProcessableTransition = null;

	private ProcessableState state = null;

	public NoMatchingTransitionConditionFoundException() {
		super();
	}

	public ProcessableTransition getCurrentProcessableTransition() {
		return currentProcessableTransition;
	}

	public void setCurrentProcessableTransition(ProcessableTransition currentProcessableTransition) {
		this.currentProcessableTransition = currentProcessableTransition;
	}

	@Override
	public String getMessage() {

		String msg = "failed at stateID=";

		if (state != null) {
			msg += state.toString();
		}
		return msg;
	}

	public ProcessableState getState() {
		return state;
	}

	public void setState(ProcessableState state) {
		this.state = state;
	}
}
