/*
 * Created on May 18, 2007
 */
package com.x8ing.lsm4j.std;

import java.util.List;

import com.x8ing.lsm4j.Action;
import com.x8ing.lsm4j.Condition;
import com.x8ing.lsm4j.StateContext;
import com.x8ing.lsm4j.state.ProcessableState;

/**
 * An Action that does nothing but stores all parameters as members.
 *
 * @author Patrick Heusser
 */
public class EmptyAction implements Action {

    private ProcessableState currentState = null;

    private StateContext stateContext = null;

    private Condition previousCondition = null;

    private List lastVisitedStatesHistory = null;

    public void execute(ProcessableState currentState, StateContext stateContext,
            Condition previousCondition, List lastVisitedStatesHistory) {

        this.currentState = currentState;
        this.stateContext = stateContext;
        this.previousCondition = previousCondition;
        this.lastVisitedStatesHistory = lastVisitedStatesHistory;

    }

    public ProcessableState getCurrentState() {
        return currentState;
    }

    public List getLastVisitedStatesHistory() {
        return lastVisitedStatesHistory;
    }

    public Condition getPreviousCondition() {
        return previousCondition;
    }

    public StateContext getStateContext() {
        return stateContext;
    }
}
