/*
 * Created on Sep 4, 2007
 */
package com.x8ing.mc.bp;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * List of bugs.
 * 
 * @author Patrick Heusser
 */
public class BugList {

	private int bugIDCounter = 0;

	/**
	 * type: Bug
	 */
	private List bugs = new ArrayList();

	public void addBug(Bug bug) {
		bugs.add(bug);
	}

	public List getAllBugs() {
		return bugs;
	}

	public int getNextBugID() {
		return ++bugIDCounter;
	}

	public List getBugsWithState(Bug.BugState[] bugState) {
		List ret = new ArrayList();

		for (int i = 0; i < bugState.length; i++) {
			Bug.BugState state = bugState[i];
			ret.addAll(getBugsWithState(state));
		}

		return ret;
	}

	public List getBugsWithState(Bug.BugState bugState) {

		List ret = new ArrayList();

		for (Iterator it = bugs.iterator(); it.hasNext();) {
			Bug bug = (Bug) it.next();
			if (bug.getBugState().equals(bugState)) {
				ret.add(bug);
			}

		}

		return ret;

	}

	public List getBugsWithStateNew() {
		return getBugsWithState(Bug.BugState.STATE_BUG_NEW);
	}

	public List getBugsWithStateFixed() {
		return getBugsWithState(Bug.BugState.STATE_BUG_FIXED);
	}

	public List getBugsWithStateDeployed() {
		return getBugsWithState(Bug.BugState.STATE_BUG_DEPLOYED);
	}

	public List getBugsWithStateFixLater() {
		return getBugsWithState(Bug.BugState.STATE_BUG_FIX_LATER);
	}

	public List getBugsWithStateProductionTestFailed() {
		return getBugsWithState(Bug.BugState.STATE_BUG_TEST_FAILED);
	}

}
