/*
 * Created on Aug 30, 2007
 */
package com.x8ing.mc.bp;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Iterator;
import java.util.List;

/**
 * A very simple log book to journalize what was going on.
 * 
 * @author Patrick Heusser
 */
public class LogBook {

	private SimpleDateFormat simpleDateFormat = new SimpleDateFormat(Constants.GLOBAL_DATE_FORMAT);

	/**
	 * type: LogEntry
	 */
	private List logs = new ArrayList();

	public void addLogEntry(Calendar dateOfEvent, String text) {
		logs.add(new LogEntry(dateOfEvent, text));

		if (Constants.TRACE_DEBUG) {
			System.out.println(simpleDateFormat.format(dateOfEvent.getTime()) + "\tLogBook:\t" + text);
		}
	}

	/**
	 * for bean mode
	 */
	public String getPrintLogBook() {
		return printLogBook(true);
	}

	public String printLogBook(boolean supressSameDates) {

		StringBuffer ret = new StringBuffer();

		String lastPrintedDate = "";

		for (Iterator it = logs.iterator(); it.hasNext();) {
			LogEntry logEntry = (LogEntry) it.next();

			String currentDate = simpleDateFormat.format(logEntry.dateOfEvent.getTime());

			if (supressSameDates && currentDate.equals(lastPrintedDate)) {
				ret.append("          ");
			} else {
				ret.append(currentDate);
				ret.append(":");
			}
			lastPrintedDate = currentDate;

			ret.append("\t");
			ret.append(logEntry.text);
			ret.append("\n");

		}

		return ret.toString();

	}

	public String toString() {
		return printLogBook(false);
	}

	private static class LogEntry {

		public Calendar dateOfEvent = null;

		public String text = null;

		public LogEntry(Calendar dateOfEvent, String text) {
			super();
			this.dateOfEvent = (Calendar) dateOfEvent.clone();
			this.text = text;
		}
	}

}
