/*
 * Created on Aug 29, 2007
 */
package com.x8ing.mc.bp;

import java.text.SimpleDateFormat;
import java.util.Calendar;

/**
 * Implements a money transaction.
 * 
 * @author Patrick Heusser
 */
public class MoneyTransaction {

	private String bookingDescription = null;

	private Calendar transactionDate = null;

	private double amount = 0;

	private BalanceAccount balanceAccount = null;

	/**
	 * @param bookingDescription
	 * @param transactionDate
	 * @param amount
	 */
	public MoneyTransaction(String bookingDescription, Calendar transactionDate, double amount, BalanceAccount balanceAccount) {
		super();
		this.bookingDescription = bookingDescription;
		this.transactionDate = (Calendar) transactionDate.clone();
		this.amount = amount;
		this.balanceAccount = balanceAccount;
	}

	/**
	 * @return Returns the amount.
	 */
	public double getAmount() {
		return amount;
	}

	/**
	 * @param amount
	 *            The amount to set.
	 */
	public void setAmount(double amount) {
		this.amount = amount;
	}

	/**
	 * @return Returns the bookingDescription.
	 */
	public String getBookingDescription() {
		return bookingDescription;
	}

	/**
	 * @param bookingDescription
	 *            The bookingDescription to set.
	 */
	public void setBookingDescription(String bookingDescription) {
		this.bookingDescription = bookingDescription;
	}

	/**
	 * @return Returns the transactionDate.
	 */
	public Calendar getTransactionDate() {
		return transactionDate;
	}

	/**
	 * @param transactionDate
	 *            The transactionDate to set.
	 */
	public void setTransactionDate(Calendar transactionDate) {
		this.transactionDate = transactionDate;
	}

	public void toString(StringBuffer sb) {
		SimpleDateFormat sdf = new SimpleDateFormat(Constants.GLOBAL_DATE_FORMAT);
		sb.append(sdf.format(transactionDate.getTime()));
		sb.append("amount:");
		sb.append(amount);
		sb.append("\t desc");
		sb.append(bookingDescription);
		sb.append(" account:" + balanceAccount.getName());
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		toString(sb);
		return sb.toString();
	}

	public BalanceAccount getBalanceAccount() {
		return balanceAccount;
	}

	public void setBalanceAccount(BalanceAccount balanceAccount) {
		this.balanceAccount = balanceAccount;
	}
}
