/*
 * Created on Aug 29, 2007
 */
package com.x8ing.mc.bp.develop;

import java.util.Iterator;
import java.util.List;

import com.x8ing.lsm4j.Condition;
import com.x8ing.lsm4j.state.ProcessableState;
import com.x8ing.mc.bp.AbstractBusinessAction;
import com.x8ing.mc.bp.BalanceAccount;
import com.x8ing.mc.bp.Bug;
import com.x8ing.mc.bp.BusinessContext;

/**
 * @author Patrick Heusser
 */
public class AddBugToFixListAction extends AbstractBusinessAction {

	/**
	 * @see com.x8ing.mc.bp.AbstractBusinessAction#execute(com.x8ing.lsm4j.state.ProcessableState,
	 *      com.x8ing.mc.bp.BusinessContext, com.x8ing.lsm4j.Condition, java.util.List)
	 */
	public void execute(ProcessableState currentState, BusinessContext businessContext, Condition previousCondition,
			List lastVisitedStatesHistory) {

		// our work finished
		businessContext.setDevelopProcessBusy(false);

		for (Iterator bugIt = businessContext.getBugs().getBugsWithStateNew().iterator(); bugIt.hasNext();) {

			Bug bug = (Bug) bugIt.next();
			bug.setBugState(Bug.BugState.STATE_BUG_FIX_LATER);

			addBalanceSheetTransaction("cost for add bug (id=" + bug.getBugID() + ") to fix later list.", -businessContext
					.getConfiguration().getCostActionAddBugToFixList(), BalanceAccount.DEVELOP);

			addLogBookEntry("Added bug (id=" + bug.getBugID()
					+ ") to fix-later-list. It was not worth to fix it immediately. Current sum of bug caused loss:"
					+ businessContext.calculateTotalProcessLossOfAllBugsNotDeployedYet());

		}

	}

	protected void lazyInit() {
		// empty

	}
}
