/*
 * Created on Aug 29, 2007
 *
 */
package com.x8ing.mc.bp.develop;

import java.util.List;

import com.x8ing.lsm4j.Condition;
import com.x8ing.lsm4j.StateContext;
import com.x8ing.mc.bp.BusinessContext;

/**
 * 
 * @author Patrick Heusser
 */
public class BugFixedCondition implements Condition {

	private boolean inverse = false;

	public BugFixedCondition(boolean inverse) {
		this.inverse = inverse;
	}

	/**
	 * @see com.x8ing.lsm4j.Condition#traceInfo()
	 */
	public String traceInfo() {

		return "";
	}

	/**
	 * @see com.x8ing.lsm4j.Condition#conditionTrue(com.x8ing.lsm4j.StateContext)
	 */
	public boolean conditionTrue(StateContext currentContext) {

		BusinessContext businessContext = (BusinessContext) currentContext;

		List allBugs = businessContext.getBugs().getBugsWithState(FixAllKnownBugsAction.STATES_TO_FIX);

		boolean fixedWithSuccess = allBugs.isEmpty();

		return inverse ? !fixedWithSuccess : fixedWithSuccess;

	}

}
