/*
 * Created on Aug 29, 2007
 *
 */
package com.x8ing.mc.bp.develop;

import com.x8ing.lsm4j.Condition;
import com.x8ing.lsm4j.StateContext;
import com.x8ing.mc.bp.BusinessContext;

/**
 * 
 * @author Patrick Heusser
 */
public class CostLossCheckCondition implements Condition {

	private boolean trueIfLossIsGreaterThen = false;

	/**
	 * the value of cost loss must be above this value
	 */
	private double triggerValue = -1;

	public CostLossCheckCondition(boolean trueIfLossIsGreaterThen, double triggerValue) {
		this.trueIfLossIsGreaterThen = trueIfLossIsGreaterThen;
		this.triggerValue = triggerValue;
	}

	/**
	 * @see com.x8ing.lsm4j.Condition#traceInfo()
	 */
	public String traceInfo() {

		return "";
	}

	/**
	 * @see com.x8ing.lsm4j.Condition#conditionTrue(com.x8ing.lsm4j.StateContext)
	 */
	public boolean conditionTrue(StateContext currentContext) {

		BusinessContext businessContext = (BusinessContext) currentContext;

		// log just once this information
		double totalLoss = businessContext.calculateTotalProcessLossOfAllBugsNotDeployedYet();

		boolean ret = totalLoss >= triggerValue;

		return trueIfLossIsGreaterThen ? !ret : ret;

	}

}
