/*
 * Created on Aug 29, 2007
 */
package com.x8ing.mc.bp.develop;

import java.util.List;

import com.x8ing.lsm4j.Condition;
import com.x8ing.lsm4j.state.ProcessableState;
import com.x8ing.mc.bp.AbstractBusinessAction;
import com.x8ing.mc.bp.BalanceAccount;
import com.x8ing.mc.bp.BusinessContext;

/**
 * @author Patrick Heusser
 */
public class DocumentAndFinishProcessAction extends AbstractBusinessAction {

	/**
	 * @see com.x8ing.mc.bp.AbstractBusinessAction#execute(com.x8ing.lsm4j.state.ProcessableState,
	 *      com.x8ing.mc.bp.BusinessContext, com.x8ing.lsm4j.Condition, java.util.List)
	 */
	public void execute(ProcessableState currentState, BusinessContext businessContext, Condition previousCondition,
			List lastVisitedStatesHistory) {

		// our work finished
		businessContext.setDevelopProcessBusy(false);

		addBalanceSheetTransaction("finished develop process. updated documentation.", -businessContext.getConfiguration()
				.getCostActionDocumentAndFinishProcess(), BalanceAccount.DEVELOP);

		addLogBookEntry("develop process finished. documentation updated.");

	}

	protected void lazyInit() {
		// empty
	}

}
