/*
 * Created on Aug 29, 2007
 */
package com.x8ing.mc.bp.develop;

import java.util.Iterator;
import java.util.List;

import com.x8ing.lsm4j.Condition;
import com.x8ing.lsm4j.state.ProcessableState;
import com.x8ing.mc.bp.AbstractBusinessAction;
import com.x8ing.mc.bp.BalanceAccount;
import com.x8ing.mc.bp.Bug;
import com.x8ing.mc.bp.BusinessContext;
import com.x8ing.mc.distribution.RandomDistribution;
import com.x8ing.mc.distribution.RandomDistributionConstant;

/**
 * @author Patrick Heusser
 */
public class TestingAction extends AbstractBusinessAction {

	private RandomDistribution testingSucess = new RandomDistributionConstant(0, 100);

	/**
	 * @see com.x8ing.mc.bp.AbstractBusinessAction#execute(com.x8ing.lsm4j.state.ProcessableState,
	 *      com.x8ing.mc.bp.BusinessContext, com.x8ing.lsm4j.Condition, java.util.List)
	 */
	public void execute(ProcessableState currentState, BusinessContext businessContext, Condition previousCondition,
			List lastVisitedStatesHistory) {

		addLogBookEntry("Started testing");

		// book costs for testing
		addBalanceSheetTransaction("Testing costs", -businessContext.getConfiguration().getCostActionTesting(),
				BalanceAccount.TESTING);

		// check if fix was successful
		for (Iterator it = businessContext.getBugs().getBugsWithStateFixed().iterator(); it.hasNext();) {

			Bug bug = (Bug) it.next();

			boolean bugFixedWithSucess = (testingSucess.getNextRandomNumber() < businessContext.getConfiguration()
					.getChanceTestingBugWithSuccess() ? true : false);

			if (bugFixedWithSucess) {

				addLogBookEntry("testing of bug (id=" + bug.getBugID() + ") sucessful.");
				bug.setBugState(Bug.BugState.STATE_BUG_TEST_SUCESS);

			} else {

				addLogBookEntry("testing of bug (id=" + bug.getBugID() + ") failed. Return bug to developers.");
				bug.setBugState(Bug.BugState.STATE_BUG_TEST_FAILED);
			}

		}

	}

	protected void lazyInit() {
		// empty
	}

}
