/*
 * Created on Aug 29, 2007
 *
 */
package com.x8ing.mc.bp.develop;

import java.util.List;

import com.x8ing.lsm4j.Condition;
import com.x8ing.lsm4j.StateContext;
import com.x8ing.mc.bp.Bug;
import com.x8ing.mc.bp.BusinessContext;

/**
 * Returns true if the getBugsToBeFixed list is empty.
 * 
 * @author Patrick Heusser
 */
public class TestingPassedCondition implements Condition {

	private boolean inverse = false;

	public TestingPassedCondition(boolean inverse) {
		this.inverse = inverse;
	}

	/**
	 * @see com.x8ing.lsm4j.Condition#traceInfo()
	 */
	public String traceInfo() {

		return "";
	}

	/**
	 * @see com.x8ing.lsm4j.Condition#conditionTrue(com.x8ing.lsm4j.StateContext)
	 */
	public boolean conditionTrue(StateContext currentContext) {

		BusinessContext businessContext = (BusinessContext) currentContext;

		List testingFailedBugs = businessContext.getBugs().getBugsWithState(Bug.BugState.STATE_BUG_TEST_FAILED);

		boolean testingSuccessful = testingFailedBugs.isEmpty();

		return inverse ? !testingSuccessful : testingSuccessful;

	}
}
