/*
 * Created on Aug 29, 2007
 */
package com.x8ing.mc.bp.operation;

import java.util.List;

import com.x8ing.lsm4j.Condition;
import com.x8ing.lsm4j.state.ProcessableState;
import com.x8ing.mc.bp.AbstractBusinessAction;
import com.x8ing.mc.bp.BalanceAccount;
import com.x8ing.mc.bp.BusinessContext;
import com.x8ing.mc.distribution.RandomDistribution;
import com.x8ing.mc.distribution.RandomDistributionConstant;

/**
 * @author Patrick Heusser
 */
public class OperationDownAction extends AbstractBusinessAction {

	private RandomDistribution failureResolveChance = new RandomDistributionConstant(0, 100);

	/**
	 * @see com.x8ing.mc.bp.AbstractBusinessAction#execute(com.x8ing.lsm4j.state.ProcessableState,
	 *      com.x8ing.mc.bp.BusinessContext, com.x8ing.lsm4j.Condition, java.util.List)
	 */
	public void execute(ProcessableState currentState, BusinessContext businessContext, Condition previousCondition,
			List lastVisitedStatesHistory) {

		// book money
		addBalanceSheetTransaction("Production down: Outage costs.", -businessContext.getConfiguration()
				.getOperationCostForOutagePerDay(), BalanceAccount.PRODUCTION);

		// log info
		addLogBookEntry("Production system is down.");

		// check if we can fix the fug
		if (failureResolveChance.getNextRandomNumber() < businessContext.getConfiguration()
				.getChanceOperationDownResolvingWithSuccess()) {

			// we have a problem
			businessContext.setProductionSystemRunning(true);

			addLogBookEntry("production failure resolved.");

		} else {
			addLogBookEntry("production failure not yet resolved.");

		}

	}

	protected void lazyInit() {
		// empty
	}

}
