/*
 * Created on Aug 29, 2007
 *
 */
package com.x8ing.mc.bp.operation;

import com.x8ing.lsm4j.Condition;
import com.x8ing.lsm4j.StateContext;
import com.x8ing.mc.bp.BusinessContext;

/**
 * This condition depends on the state of the production system, if it's up and running or down with a heavy failure.
 * 
 * @author Patrick Heusser
 */
public class OperationRunningDependentCondition implements Condition {

	private boolean inverse = false;

	public OperationRunningDependentCondition(boolean trueIfSystemRunning) {
		this.inverse = !trueIfSystemRunning;
	}

	/**
	 * @see com.x8ing.lsm4j.Condition#traceInfo()
	 */
	public String traceInfo() {

		return "";
	}

	/**
	 * @see com.x8ing.lsm4j.Condition#conditionTrue(com.x8ing.lsm4j.StateContext)
	 */
	public boolean conditionTrue(StateContext currentContext) {

		BusinessContext businessContext = (BusinessContext) currentContext;

		boolean ret = businessContext.isProductionSystemRunning();

		return inverse ? !ret : ret;

	}

}
