/*
 * Created on Aug 30, 2007
 */
package com.x8ing.mc.distribution;

import java.util.Random;

/**
 * Uses the functionality that java provides itself.
 * 
 * @author Patrick Heusser
 */
public class RandomDistributionConstant implements RandomDistribution {

	private Random rnd = new Random();

	private int rangeMin = -1;

	private int rangeMax = -1;

	public RandomDistributionConstant(int rangeMin, int rangeMax) {
		super();
		this.rangeMin = rangeMin;
		this.rangeMax = rangeMax;
	}

	/**
	 * @see com.x8ing.mc.distribution.RandomDistribution#getNextRandomNumber()
	 */
	public double getNextRandomNumber() {

		int spread = rangeMax - rangeMin;

		return rnd.nextDouble() * spread + rangeMin;

	}

	public int getRangeMax() {
		return rangeMax;
	}

	public void setRangeMax(int rangeMax) {
		this.rangeMax = rangeMax;
	}

	public int getRangeMin() {
		return rangeMin;
	}

	public void setRangeMin(int rangeMin) {
		this.rangeMin = rangeMin;
	}

}
