package com.x8ing.mc.web;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Locale;

import jakarta.servlet.ServletRequestEvent;
import jakarta.servlet.ServletRequestListener;
import jakarta.servlet.http.HttpServletRequest;

public class GlobalRequestListener implements ServletRequestListener {

	public void requestDestroyed(ServletRequestEvent sre) {
		// get perflog event from request
	}

	public void requestInitialized(ServletRequestEvent sre) {

		HttpServletRequest req = (HttpServletRequest) sre.getServletRequest();

		String sessionID = "null";
		if (req.getSession() != null) {
			sessionID = req.getSession().getId();
		}

		String mimeType = req.getContentType();

		String remoteInfo = "remoteAddr=" + req.getRemoteAddr() + " remoteHost=" + req.getRemoteHost() + " referer="
				+ req.getHeader("Referer") + " user=" + req.getRemoteUser() + " remotePort=" + req.getRemotePort()
				+ " sessionID=" + sessionID;
		String servletInfo = "servletPath=" + req.getServletPath();

		DateFormat df = new SimpleDateFormat("yyyy.MM.dd HH:mm:ss.S", Locale.GERMAN);

		System.out.println(df.format(Calendar.getInstance().getTime()) + " request: " + remoteInfo + " " + servletInfo
				+ " mimeType=" + mimeType);

	}

}
