/*
 * Created on Sep 21, 2007
 */
package com.x8ing.mc.web;

import java.text.DecimalFormat;

import jakarta.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

import com.x8ing.mc.Configuration;
import com.x8ing.mc.MonteCarloControler;
import com.x8ing.mc.Statistic;
import com.x8ing.mc.bp.Constants;

/**
 * 
 * @author Patrick Heusser
 */
public class MCForm extends ActionForm {

	private static final long serialVersionUID = -3131385288285080580L;

	private Configuration configuration = new Configuration();

	private MonteCarloControler monteCarloControlerResult = null;

	public String getEarningAverage() {

		if (monteCarloControlerResult != null) {
			Statistic statistic = new Statistic(monteCarloControlerResult.getBalanceValues());
			DecimalFormat df = Constants.createCurrencyFormater();

			return df.format(statistic.getAverage());
		}
		return "n/a";
	}

	public String getEarningMaximum() {
		if (monteCarloControlerResult != null) {
			Statistic statistic = new Statistic(monteCarloControlerResult.getBalanceValues());
			DecimalFormat df = Constants.createCurrencyFormater();

			return df.format(statistic.getMinimumAndMaximum()[1]);
		}
		return "n/a";
	}

	public String getEarningMinimum() {
		if (monteCarloControlerResult != null) {
			Statistic statistic = new Statistic(monteCarloControlerResult.getBalanceValues());
			DecimalFormat df = Constants.createCurrencyFormater();
			return df.format(statistic.getMinimumAndMaximum()[0]);
		}
		return "n/a";
	}

	public Configuration getConfiguration() {
		return configuration;
	}

	public void setConfiguration(Configuration configuration) {
		this.configuration = configuration;
	}

	public MonteCarloControler getMonteCarloControlerResult() {
		return monteCarloControlerResult;
	}

	public void setMonteCarloControlerResult(MonteCarloControler monteCarloControlerResult) {
		this.monteCarloControlerResult = monteCarloControlerResult;
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {

		ActionErrors actionErrors = new ActionErrors();

		final int maxCompleteSimulationLoops = 10000;
		final int maxCollectMaxNumberOfBusinessContext = 20;
		final int maxNumberOfSimulationDays = 180;

		if (configuration.getNumberCompleteSimulationLoops() > maxCompleteSimulationLoops) {

			actionErrors.add("configuration.numberCompleteSimulationLoops", new ActionMessage("validation.simloops", String
					.valueOf(maxCompleteSimulationLoops)));
		}

		if (configuration.getCollectMaxNumberOfBusinessContext() > maxCollectMaxNumberOfBusinessContext) {

			actionErrors.add("configuration.collectMaxNumberOfBusinessContext", new ActionMessage(
					"validation.collectMaxNumberOfBusinessContext", String.valueOf(maxCollectMaxNumberOfBusinessContext)));
		}

		if (configuration.getNumberOfSimulationDays() > maxNumberOfSimulationDays) {

			actionErrors.add("configuration.numberOfSimulationDays", new ActionMessage("validation.maxNumberSimulationDays",
					String.valueOf(maxNumberOfSimulationDays)));
		}

		return actionErrors;
	}

}
