/*
 * Created on Sep 21, 2007
 */
package com.x8ing.mc.web;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.x8ing.mc.Configuration;
import com.x8ing.mc.MonteCarloControler;

/**
 * @author pheusser
 * 
 */
public class ProcessMCAction extends Action {

	public static final String SESSION_KEY_MONTE_CARLO_CONTRLOER = "session_key_mcc";

	public static final String REQ_PARAM_BUTTON_START = "buttonStart";

	public static final String REQ_PARAM_BUTTON_RESET = "buttonReset";

	public ActionForward execute(ActionMapping mapping, ActionForm inForm, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		MCForm form = (MCForm) inForm;

		if (request.getParameter(REQ_PARAM_BUTTON_START) != null) {

			// start simulation

			String msg = "Start simulation with params: " + form.getConfiguration().toString();
			System.out.println(msg);

			MonteCarloControler mcc = new MonteCarloControler(form.getConfiguration());
			mcc.runBusinessProcessSimulation();

			// add it to form, as the controler can be regarded as the result
			form.setMonteCarloControlerResult(mcc);

			// add a reference directly to session: for image servlet
			request.getSession().setAttribute(SESSION_KEY_MONTE_CARLO_CONTRLOER, mcc);

			return mapping.findForward("success");

		} else if (request.getParameter(REQ_PARAM_BUTTON_RESET) != null) {

			String msg = "reset configuration";
			System.out.println(msg);

			form.setConfiguration(new Configuration());

			return mapping.findForward("reset");

		} else {

			// command not understood
			return mapping.getInputForward();

		}
	}

}
