/*
 * Created on Sep 14, 2007
 *
 */
package com.x8ing.mc;

import junit.framework.TestCase;

import com.x8ing.mc.distribution.RandomDistribution;
import com.x8ing.mc.distribution.RandomDistributionConstant;
import com.x8ing.mc.distribution.RandomDistributionGauss;

/**
 * @author Patrick Heusser
 */
public class DistributedRandomFactoryTest extends TestCase {

	public static final int LOOPS = 1000;

	public void testConstant1() {

		// check interval (heuristic test)
		int rangeMin = 0;
		int rangeMax = 100;
		RandomDistribution rnd = new RandomDistributionConstant(rangeMin, rangeMax);
		implTest(rangeMin, rangeMax, rnd);

	}

	public void testConstant2() {

		// check interval (heuristic test)
		int rangeMin = -100;
		int rangeMax = -50;
		RandomDistribution rnd = new RandomDistributionConstant(rangeMin, rangeMax);
		implTest(rangeMin, rangeMax, rnd);

	}

	public void testGauss1() {

		// check interval (heuristic test)
		int rangeMin = 100;
		int rangeMax = 300;
		RandomDistribution rnd = new RandomDistributionGauss(rangeMin, rangeMax, 1);

		final int LOOPS = 100000;
		double[] d = new double[LOOPS];

		for (int i = 0; i < d.length; i++) {
			d[i] = rnd.getNextRandomNumber();
		}

		implTest(rangeMin, rangeMax, rnd);

		Statistic statistic = new Statistic(d);
		System.out.println(statistic.getDistributionPrint(100));

	}

	private void implTest(int rangeMin, int rangeMax, RandomDistribution rnd) {

		for (int i = 0; i < LOOPS; i++) {

			double r = rnd.getNextRandomNumber();

			assertTrue(r <= rangeMax);
			assertTrue(r >= rangeMin);

		}
	}

}
