/*
 * Created on May 14, 2007
 */
package com.x8ing.lsm4j;

import com.x8ing.lsm4j.state.NoMatchingTransitionConditionFoundException;

/**
 * A condition is an expression that is appended to a transition between to
 * states. If the processing leaves one state, all conditions are evaluated in random order. The
 * first condition which results in "true" will be selected for further processing and the
 * controler follows this transaction.
 * <p>
 * If no transaction is found which results true, an exception is thrown. {@link NoMatchingTransitionConditionFoundException}.
 *
 * @author Patrick Heusser
 */
public interface Condition {

    public String traceInfo();

    public boolean conditionTrue(StateContext currentContext);

}
