/*
 * Created on May 19, 2007
 */
package com.x8ing.lsm4j;

import com.x8ing.lsm4j.state.ProcessableGraph;
import com.x8ing.lsm4j.state.ProcessableState;

/**
 * Will be notified if something happens on the graph.
 *
 * The listener must be registred on the observeable graph. see: {@link ProcessableGraph#registerGraphListener(GraphListener)}
 * <p>
 * The usage of this interface is optional.
 *
 * @author Patrick Heusser
 */
public interface GraphListener {

	// TODO refactor order of params
	public void startProcessingState(ProcessableState previousState, Condition previosCondition, long loop,StateContext currentStateContext);

	/**
	 * The listener will be notified using this message, if the graph changed it's state. <br>
	 */
	public void changedState(ProcessableState previousState, ProcessableState currentState, Condition previousCondition,
			Condition currentCondition, long loop,StateContext currentStateContext);

	// TODO check naming!!! for all..
	public void foundEndState(ProcessableState endState, long loop, StateContext currentStateContext);

}
