/*
 * Created on May 14, 2007
 */
package com.x8ing.lsm4j.processable;

import com.x8ing.lsm4j.state.StaticGraph;
import com.x8ing.lsm4j.state.StaticState;

import junit.framework.TestCase;

/**
 * TODO add test for duplicate adding!
 *
 * @author Patrick Heusser
 */
public class StaticGraphTest extends TestCase {

    public void test1() {

        StaticState state1 = new StaticState(1, "state1");
        StaticState state2 = new StaticState(2, "state2");
        StaticState state3 = new StaticState(3, "state3");
        StaticState state4 = new StaticState(4, "state4");
        StaticState state5 = new StaticState(5, "state5");

        StaticGraph validTransitions = new StaticGraph();

        validTransitions.addValidTransition(state1, state2);
        validTransitions.addValidTransition(state2, state4);
        validTransitions.addValidTransition(state4, state2);
        validTransitions.addValidTransition(state1, state3);
        validTransitions.addValidTransition(state3, state3); // loop

        // counting transitions
        assertEquals(5 , validTransitions.getTransitionsCount());
        assertEquals(4 , validTransitions.getStateCount());


        System.out.println(validTransitions.toString());

        // logical valid transitions
        assertTrue(validTransitions.isValidTransition(state1, state2));
        assertTrue(validTransitions.isValidTransition(state2, state4));
        assertTrue(validTransitions.isValidTransition(state4, state2));
        assertTrue(validTransitions.isValidTransition(state1, state3));
        assertTrue(validTransitions.isValidTransition(state3, state3));

        // logical wrong transitions
        assertFalse(validTransitions.isValidTransition(state2, state1));
        assertFalse(validTransitions.isValidTransition(state3, state1));
        assertFalse(validTransitions.isValidTransition(state3, state4));
        assertFalse(validTransitions.isValidTransition(state4, state3));
        assertFalse(validTransitions.isValidTransition(state3, state2));
        assertFalse(validTransitions.isValidTransition(state2, state3));
        assertFalse(validTransitions.isValidTransition(state1, state1)); // loop
        assertFalse(validTransitions.isValidTransition(state2, state2)); // loop
        assertFalse(validTransitions.isValidTransition(state4, state4)); // loop

        // not present in transition set
        assertFalse(validTransitions.isValidTransition(state5, state5));
        assertFalse(validTransitions.isValidTransition(state1, state5));
        assertFalse(validTransitions.isValidTransition(state5, state1));
        assertFalse(validTransitions.isValidTransition(state5, state1));

    }

}
