/*
 * Created on May 14, 2007
 */
package com.x8ing.lsm4j.state;

import com.x8ing.lsm4j.Action;
import com.x8ing.lsm4j.Condition;

/**
 * 
 * @author Patrick Heusser
 */
public class ProcessableTransition extends StaticTransition {

    private Condition condition = null;

    /**
     * optional action may be null.
     */
    private Action action = null;

    /**
     * @param currentState
     * @param nextState
     */
    public ProcessableTransition(ProcessableState currentState, ProcessableState nextState,
            Condition condition) {

        super(currentState, nextState);
        this.condition = condition;

    }

    public ProcessableTransition(ProcessableState currentState, ProcessableState nextState,
            Condition condition, Action transitionAction) {
        this(currentState, nextState, condition);
        this.action = transitionAction;
    }

    public boolean equals(Object obj) {

        if (obj == null || !(obj instanceof ProcessableTransition)) {
            return false;
        }
        ProcessableTransition p2 = (ProcessableTransition) obj;

        // check if conditions are equally
        boolean eqCond = condition.equals(p2.condition);
        boolean eqTrans = super.equals(p2);

        return eqCond && eqTrans;
    }

    public int hashCode() {
        return super.hashCode() + 192329 * condition.hashCode();
    }

    public Condition getCondition() {
        return condition;
    }

    public void setCondition(Condition condition) {
        this.condition = condition;
    }

    public ProcessableState getCurrentProcessableState() {
        return (ProcessableState) currentState;
    }

    public ProcessableState getNextProcessableState() {
        return (ProcessableState) nextState;
    }

    public Action getAction() {
        return action;
    }

    public void setAction(Action action) {
        this.action = action;
    }
}
