/*
 * Created on May 14, 2007
 */
package com.x8ing.lsm4j.state;

import com.x8ing.lsm4j.StateMetaInformation;

/**
 * A state.
 * 
 * @author Patrick Heusser
 */
public class StaticState {

	private int uniqueID = -1;

	private String description = null;

	private StateMetaInformation stateMetaInformation = null;

	public StaticState(int uniqueID, String description, StateMetaInformation stateMetaInformation) {
		this(uniqueID, description);
		setStateMetaInformation(stateMetaInformation);
	}

	public StaticState(int uniqueID, String description) {

		this.uniqueID = uniqueID;
		this.description = description;

	}

	public void addNextState() {

	}

	public int hashCode() {
		return uniqueID;
	}

	public boolean equals(Object obj) {

		if (obj == null || !(obj instanceof StaticState)) {
			return false;
		}

		StaticState s2 = (StaticState) obj;

		return this.uniqueID == s2.uniqueID;

	}

	public String toString() {
		return "StaticState {uniqueID=" + uniqueID + " description=" + description + " }";
	}

	public String getUniqueIDString() {
		return String.valueOf(uniqueID);
	}

	public int getUniqueID() {
		return uniqueID;
	}

	public String getDescription() {
		return description;
	}

	public StateMetaInformation getStateMetaInformation() {
		return stateMetaInformation;
	}

	public void setStateMetaInformation(StateMetaInformation stateMetaInformation) {
		this.stateMetaInformation = stateMetaInformation;
	}
}