/*
 * Created on May 14, 2007
 */
package com.x8ing.lsm4j.state;

/**
 * Defines a transition between two states.
 * 
 * @author Patrick Heusser
 */
public class StaticTransition {

	protected StaticState currentState = null;

	protected StaticState nextState = null;

	public StaticTransition(StaticState currentState, StaticState nextState) {

		if (currentState == null || nextState == null) {
			String msg = "IllegalStateTransition. StaticState must not be null. currentState=" + currentState + " nextState="
					+ nextState;
			throw new IllegalArgumentException(msg);
		}

		this.currentState = currentState;
		this.nextState = nextState;

	}

	public boolean equals(Object obj) {

		if (obj == null || !(obj instanceof StaticTransition)) {
			return false;
		}

		StaticTransition t2 = (StaticTransition) obj;

		return this.currentState.equals(t2.currentState) && this.nextState.equals(t2.nextState);
	}

	public int hashCode() {
		return currentState.hashCode() * 1337 + nextState.hashCode();
	}

	public String toString() {
		return "StaticTransition {currentState=" + currentState + " nextState=" + nextState + " } ";
	}

	public StaticState getCurrentState() {
		return currentState;
	}

	public StaticState getNextState() {
		return nextState;
	}

}